%Part A. - Step response of ex1_2
Start = 0;
End = 100;
L=End - Start + 1;
nn = Start:End;

Zeros = [1, 0.5];
Poles = [1, -1.7654, +0.81];
x = 3 * ones (L, 1);
y = filter (Zeros, Poles, x);		% Complex exponential
stem(nn,y), grid, title ('Filter impulse response'), xlabel ('Index (n)');
disp 'Please hit a key to continue ...', pause;


%Part C. - Step response error

ConstOutput = 100.89;
NewEnd = 50;
NewL=NewEnd - Start + 1;
nn2 = Start:NewEnd;
y2 = ConstOutput - y(1:NewL);		% Crop buffer
stem(nn2,y2), grid, title ('Filter impulse response error'), xlabel ('Index (n)');
disp 'Please hit a key to continue ...', pause;


%Part E. - Differential of step response == impulse response

x = ones (L, 1);		% Generate delayed unit step response
x(1) = 0;
y = filter (Zeros, Poles, x);		% Complex exponential
stem(nn,y), grid, title ('Filter impulse response'), xlabel ('Index (n)');

NewEnd = 99;		% Generate impulse response
NewL=NewEnd - Start + 1;
nn3 = Start:NewEnd;
x = genimp (Start, NewEnd, 0, 1);
y3 = filter (Zeros, Poles, x);		% Complex exponential
stem(nn3,y3), grid, title ('Filter impulse response'), xlabel ('Index (n)');
disp 'Please hit a key to continue ...', pause;

y4 = diff (y);		% Differentiate step response
stem(nn3,y4), grid, title ('Differentiation of step response'), xlabel ('Index (n)');
disp 'Please hit a key to continue ...', pause;

y5 = y4 - y3;		% See what the error is
stem(nn3,y5), grid, title ('Difference between delta (step response) and impulse response'), xlabel ('Index (n)');

