% Example for DTFT

SourceStart = 0;
SourceLen = 256;
DTFLen = SourceLen;
PulseStart = 0;
PulseLen = 12;
SincLen = 12;

format compact, subplot (1,1,1);
nn = 0:SourceLen-1;

			% Generate vector of frequencies
W = (2*pi/SourceLen) * [ 0:(SourceLen-1) ]';
mid = ceil(SourceLen/2) + 1;
W(mid:SourceLen) = W(mid:SourceLen) - 2*pi;   % <--- move [pi,2pi) to [-pi,0)
W = fftshift(W);

subplot (2,1,1), plot (nn, W); grid, title('Frequency vector');

xn = asinc (W, SincLen);
subplot (2,1,2), plot (nn, xn); grid, title('asinc of frequencies');
disp 'Please hit a key to continue ...', pause;

[X,W] = dtft (xn, DTFLen);
subplot (2,1,1), plot (W/2/pi, abs(X)); grid, title('Magnitude Reasponse'), xlabel ('Normalised Frequency w0'), ylabel ('| H(w) |')
subplot (2,1,2), plot (W/2/pi, 180 / pi * angle (X)); grid, title('Phase Reasponse'), xlabel ('Normalised Frequency w0'), ylabel ('Degrees')
