% Example for DTFT_n0 includes phase unwrapping

SourceStart = -128;
SourceEnd = 127;
SourceLen = SourceEnd - SourceStart + 1;
DTFTLen = SourceLen;
PulseStart = -10;
PulseLen = 21;
n0 = SourceStart;

format compact, subplot (1,1,1);
nn = SourceStart:SourceEnd;

xn = genpulse (SourceStart, SourceEnd, PulseStart, 1, PulseLen);
subplot (2,1,1), plot (nn, xn); grid, title('Real input');
disp 'Please hit a key to continue ...', pause;

[X,W] = dtft_n0 (xn, n0, DTFTLen);
subplot (3,1,1), plot (W/2/pi, abs(X)); grid, title('Magnitude Reasponse'), xlabel ('Normalised Frequency w0'), ylabel ('| H(w) |')

subplot (3,1,2), plot (W/2/pi, real(X)); grid, title('Real Reasponse'), xlabel ('Normalised Frequency w0'), ylabel ('Re(| H(w) |)')
subplot (3,1,3), plot (W/2/pi, imag(X)); grid, title('Imaginary Reasponse'), xlabel ('Normalised Frequency w0'), ylabel ('Im(| H(w) |)')
disp 'Please hit a key to continue ...', pause;

subplot (3,1,2), plot (W/2/pi, 180 / pi * angle (X)); grid, title('Phase Reasponse'), xlabel ('Normalised Frequency w0'), ylabel ('Degrees')
subplot (3,1,3), plot (W/2/pi, 180 / pi * unwrap(angle (X))); grid, title('Phase Reasponse (unwrapped)'), xlabel ('Normalised Frequency w0'), ylabel ('Degrees')
