% Example 2.2 for DTFT_n0 includes phase unwrapping

SourceStart = 0;
SourceEnd = 21;
SourceLen = SourceEnd - SourceStart + 1;
DTFTLen = SourceLen;
n0 = SourceStart;

format compact, subplot (1,1,1);
nn = SourceStart:SourceEnd;
xn = (0.9 .^ nn) .* cos(2 * pi*nn/sqrt(31));
yn = 1j .* xn;

subplot (3,1,1), plot (nn, xn); grid, title('Real input');
subplot (3,1,2), plot (nn, real(yn)); grid, title('real(yn)');
subplot (3,1,3), plot (nn, imag(yn)); grid, title('imag(yn)');
disp 'Please hit a key to continue ...', pause;

[Y,W] = dtft_n0 (yn, n0, DTFTLen);
subplot (3,1,1), plot (W/2/pi, abs(Y)); grid, title('Magnitude Reasponse'), xlabel ('Normalised Frequency w0'), ylabel ('| H(w) |')
[G,WFlipped] = flipdtft (Y, W);

subplot (3,1,2), plot (W/2/pi, real(Y)); grid, title('Real Reasponse'), xlabel ('Normalised Frequency w0'), ylabel ('Re(| H(w) |)')
subplot (3,1,3), plot (W/2/pi, imag(Y)); grid, title('Imaginary Reasponse'), xlabel ('Normalised Frequency w0'), ylabel ('Im(| H(w) |)')
disp 'Please hit a key to continue ...', pause;

subplot (3,1,2), plot (WFlipped/2/pi, real(G)); grid, title('Real Reasponse (Flipped)'), xlabel ('Normalised Frequency w0'), ylabel ('Re(| H(w) |)')
subplot (3,1,3), plot (WFlipped/2/pi, imag(G)); grid, title('Imaginary Reasponse (Flipped)'), xlabel ('Normalised Frequency w0'), ylabel ('Im(| H(w) |)')
disp 'Please hit a key to continue ...', pause;


subplot (3,1,2), plot (W/2/pi, 180 / pi * angle (Y)); grid, title('Phase Reasponse'), xlabel ('Normalised Frequency w0'), ylabel ('Degrees')
subplot (3,1,3), plot (W/2/pi, 180 / pi * unwrap(angle (Y))); grid, title('Phase Reasponse (unwrapped)'), xlabel ('Normalised Frequency w0'), ylabel ('Degrees')
disp 'Please hit a key to continue ...', pause;

subplot (3,1,2), plot (WFlipped/2/pi, 180 / pi * angle (G)); grid, title('Phase Reasponse (Flipped)'), xlabel ('Normalised Frequency w0'), ylabel ('Degrees')
subplot (3,1,3), plot (WFlipped/2/pi, 180 / pi * unwrap(angle (G))); grid, title('Phase Reasponse (unwrapped & Flipped)'), xlabel ('Normalised Frequency w0'), ylabel ('Degrees')

