% Example 2.2 for DTFT_n0 includes phase unwrapping

SourceStart = -30;
SourceEnd = 30;
SourceLen = SourceEnd - SourceStart + 1;
DTFTLen = SourceLen;
n0 = SourceStart;

format compact, subplot (1,1,1);
nn = SourceStart:SourceEnd;
xn = 1j * nn;

subplot (2,1,1), plot (nn, real(xn)); grid, title('Real input');
subplot (2,1,2), plot (nn, imag(xn)); grid, title('Imaginary input');
disp 'Please hit a key to continue ...', pause;

[X,W] = dtft_n0 (xn, n0, DTFTLen);
subplot (3,1,1), plot (W/2/pi, abs(X)); grid, title('Magnitude Reasponse'), xlabel ('Normalised Frequency w0'), ylabel ('| H(w) |')
[G,WFlipped] = flipdtft (X, W);

subplot (3,1,2), plot (W/2/pi, real(X)); grid, title('Real Reasponse'), xlabel ('Normalised Frequency w0'), ylabel ('Re(| H(w) |)')
subplot (3,1,3), plot (W/2/pi, imag(X)); grid, title('Imaginary Reasponse'), xlabel ('Normalised Frequency w0'), ylabel ('Im(| H(w) |)')
disp 'Please hit a key to continue ...', pause;

subplot (3,1,2), plot (WFlipped/2/pi, real(G)); grid, title('Real Reasponse (Flipped)'), xlabel ('Normalised Frequency w0'), ylabel ('Re(| H(w) |)')
subplot (3,1,3), plot (WFlipped/2/pi, imag(G)); grid, title('Imaginary Reasponse (Flipped)'), xlabel ('Normalised Frequency w0'), ylabel ('Im(| H(w) |)')
disp 'Please hit a key to continue ...', pause;


subplot (3,1,2), plot (W/2/pi, 180 / pi * angle (X)); grid, title('Phase Reasponse'), xlabel ('Normalised Frequency w0'), ylabel ('Degrees')
subplot (3,1,3), plot (W/2/pi, 180 / pi * unwrap(angle (X))); grid, title('Phase Reasponse (unwrapped)'), xlabel ('Normalised Frequency w0'), ylabel ('Degrees')
disp 'Please hit a key to continue ...', pause;

subplot (3,1,2), plot (WFlipped/2/pi, 180 / pi * angle (G)); grid, title('Phase Reasponse (Flipped)'), xlabel ('Normalised Frequency w0'), ylabel ('Degrees')
subplot (3,1,3), plot (WFlipped/2/pi, 180 / pi * unwrap(angle (G))); grid, title('Phase Reasponse (unwrapped & Flipped)'), xlabel ('Normalised Frequency w0'), ylabel ('Degrees')

