%Generating an exponential with exp and with filter

Start = -15;
End = 25;
L=End - Start + 1;
nn = Start:End;

Magn = 1.0;
Gain = 1;
RAngle = pi / 17;		% Radian angle
RPhase = 3 * pi / 2;
xx1 = ((Gain * Magn) * exp(j*(nn*RAngle + RPhase)));		% Complex exponential
subplot (2,2,1), stem(nn,real(xx1)), grid, title ('Real part'), xlabel ('Index (n)');
subplot (2,2,3), stem(nn,imag(xx1)), grid, title ('Imag part'), xlabel ('Index (n)');

ImpMagn = 1.0 + j * 1.0;
Zeros = [1] + j * [1];
Poles = [1, -0.983] + j * [1, -0.1837];	%.983+j.1837 is re^jtheta
x = genimp (Start, End, 0, real(ImpMagn)) + j * (genimp (Start, End, 0, imag(ImpMagn)));
xx2 = filter (Zeros, Poles, x);		% Complex exponential
subplot (2,2,2), stem(nn,real(xx2)), grid, title ('Real part'), xlabel ('Index (n)');
subplot (2,2,4), stem(nn,imag(xx2)), grid, title ('Imag part'), xlabel ('Index (n)');

