function y = genexp(b, n0, L)
%Exponential generation function : y = genexp(b, n0, L)
% b is input scalar giving ratio between terms
% n0 starting index (integer)
% L length of generated signal
% y output signal y(1:L)

if(L <= 0)
	error ('The length is not positive')
	end

nn = n0 + [1:L]' - 1;		% Vector of indices
y = b .^ nn;
end
